/* DeviceItem.c generated by valac 0.46.3, the Vala compiler
 * generated from DeviceItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <NetworkManager.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>

#define NETWORK_WIDGETS_TYPE_DEVICE_ITEM (network_widgets_device_item_get_type ())
#define NETWORK_WIDGETS_DEVICE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem))
#define NETWORK_WIDGETS_DEVICE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItemClass))
#define NETWORK_WIDGETS_IS_DEVICE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM))
#define NETWORK_WIDGETS_IS_DEVICE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_WIDGETS_TYPE_DEVICE_ITEM))
#define NETWORK_WIDGETS_DEVICE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItemClass))

typedef struct _NetworkWidgetsDeviceItem NetworkWidgetsDeviceItem;
typedef struct _NetworkWidgetsDeviceItemClass NetworkWidgetsDeviceItemClass;
typedef struct _NetworkWidgetsDeviceItemPrivate NetworkWidgetsDeviceItemPrivate;

#define NETWORK_WIDGETS_TYPE_PAGE (network_widgets_page_get_type ())
#define NETWORK_WIDGETS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPage))
#define NETWORK_WIDGETS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPageClass))
#define NETWORK_WIDGETS_IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_WIDGETS_TYPE_PAGE))
#define NETWORK_WIDGETS_IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_WIDGETS_TYPE_PAGE))
#define NETWORK_WIDGETS_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPageClass))

typedef struct _NetworkWidgetsPage NetworkWidgetsPage;
typedef struct _NetworkWidgetsPageClass NetworkWidgetsPageClass;
typedef enum  {
	NETWORK_UTILS_ITEM_TYPE_DEVICE = 0,
	NETWORK_UTILS_ITEM_TYPE_VIRTUAL,
	NETWORK_UTILS_ITEM_TYPE_INVALID
} NetworkUtilsItemType;

#define NETWORK_UTILS_TYPE_ITEM_TYPE (network_utils_item_type_get_type ())
enum  {
	NETWORK_WIDGETS_DEVICE_ITEM_0_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block13Data Block13Data;
typedef enum  {
	NETWORK_UTILS_CUSTOM_MODE_PROXY_NONE = 0,
	NETWORK_UTILS_CUSTOM_MODE_PROXY_MANUAL,
	NETWORK_UTILS_CUSTOM_MODE_PROXY_AUTO,
	NETWORK_UTILS_CUSTOM_MODE_HOTSPOT_ENABLED,
	NETWORK_UTILS_CUSTOM_MODE_HOTSPOT_DISABLED,
	NETWORK_UTILS_CUSTOM_MODE_INVALID
} NetworkUtilsCustomMode;

#define NETWORK_UTILS_TYPE_CUSTOM_MODE (network_utils_custom_mode_get_type ())
typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_MOBILE,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_MOBILE,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_MOBILE,
	NETWORK_STATE_FAILED_VPN
} NetworkState;

#define NETWORK_TYPE_STATE (network_state_get_type ())

struct _NetworkWidgetsDeviceItem {
	GtkListBoxRow parent_instance;
	NetworkWidgetsDeviceItemPrivate * priv;
};

struct _NetworkWidgetsDeviceItemClass {
	GtkListBoxRowClass parent_class;
};

struct _NetworkWidgetsDeviceItemPrivate {
	NMDevice* _device;
	NetworkWidgetsPage* _page;
	gchar* _title;
	gchar* _subtitle;
	gchar* _icon_name;
	NetworkUtilsItemType _item_type;
	GtkImage* status_image;
};

struct _Block13Data {
	int _ref_count_;
	NetworkWidgetsDeviceItem* self;
	NetworkWidgetsPage* page;
};

static gint NetworkWidgetsDeviceItem_private_offset;
static gpointer network_widgets_device_item_parent_class = NULL;

GType network_widgets_device_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NetworkWidgetsDeviceItem, g_object_unref)
GType network_widgets_page_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NetworkWidgetsPage, g_object_unref)
GType network_utils_item_type_get_type (void) G_GNUC_CONST;
NetworkWidgetsDeviceItem* network_widgets_device_item_new (const gchar* title,
                                                           const gchar* icon_name);
NetworkWidgetsDeviceItem* network_widgets_device_item_construct (GType object_type,
                                                                 const gchar* title,
                                                                 const gchar* icon_name);
NetworkWidgetsDeviceItem* network_widgets_device_item_new_from_page (NetworkWidgetsPage* page,
                                                                     const gchar* icon_name);
NetworkWidgetsDeviceItem* network_widgets_device_item_construct_from_page (GType object_type,
                                                                           NetworkWidgetsPage* page,
                                                                           const gchar* icon_name);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
NMDevice* network_widgets_page_get_device (NetworkWidgetsPage* self);
GType network_utils_custom_mode_get_type (void) G_GNUC_CONST;
GType network_state_get_type (void) G_GNUC_CONST;
void network_widgets_device_item_switch_status (NetworkWidgetsDeviceItem* self,
                                                NetworkUtilsCustomMode custom_mode,
                                                NetworkState* state);
NetworkState network_widgets_page_get_state (NetworkWidgetsPage* self);
static void __lambda6_ (Block13Data* _data13_);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
gchar* network_state_to_string (NetworkState self);
void network_widgets_device_item_set_subtitle (NetworkWidgetsDeviceItem* self,
                                               const gchar* value);
const gchar* network_widgets_device_item_get_subtitle (NetworkWidgetsDeviceItem* self);
NMDevice* network_widgets_device_item_get_device (NetworkWidgetsDeviceItem* self);
static void network_widgets_device_item_set_device (NetworkWidgetsDeviceItem* self,
                                             NMDevice* value);
NetworkWidgetsPage* network_widgets_device_item_get_page (NetworkWidgetsDeviceItem* self);
void network_widgets_device_item_set_page (NetworkWidgetsDeviceItem* self,
                                           NetworkWidgetsPage* value);
const gchar* network_widgets_device_item_get_title (NetworkWidgetsDeviceItem* self);
void network_widgets_device_item_set_title (NetworkWidgetsDeviceItem* self,
                                            const gchar* value);
const gchar* network_widgets_device_item_get_icon_name (NetworkWidgetsDeviceItem* self);
void network_widgets_device_item_set_icon_name (NetworkWidgetsDeviceItem* self,
                                                const gchar* value);
NetworkUtilsItemType network_widgets_device_item_get_item_type (NetworkWidgetsDeviceItem* self);
void network_widgets_device_item_set_item_type (NetworkWidgetsDeviceItem* self,
                                                NetworkUtilsItemType value);
static GObject * network_widgets_device_item_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void network_widgets_device_item_finalize (GObject * obj);
static void _vala_network_widgets_device_item_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_network_widgets_device_item_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
network_widgets_device_item_get_instance_private (NetworkWidgetsDeviceItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsDeviceItem_private_offset);
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_construct (GType object_type,
                                       const gchar* title,
                                       const gchar* icon_name)
{
	NetworkWidgetsDeviceItem * self = NULL;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	self = (NetworkWidgetsDeviceItem*) g_object_new (object_type, "title", title, "icon-name", icon_name, NULL);
	return self;
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_new (const gchar* title,
                                 const gchar* icon_name)
{
	return network_widgets_device_item_construct (NETWORK_WIDGETS_TYPE_DEVICE_ITEM, title, icon_name);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
	g_atomic_int_inc (&_data13_->_ref_count_);
	return _data13_;
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
		NetworkWidgetsDeviceItem* self;
		self = _data13_->self;
		_g_object_unref0 (_data13_->page);
		_g_object_unref0 (self);
		g_slice_free (Block13Data, _data13_);
	}
}

static void
__lambda6_ (Block13Data* _data13_)
{
	NetworkWidgetsDeviceItem* self;
	NetworkState _tmp0_;
	NetworkState _tmp1_;
	self = _data13_->self;
	_tmp0_ = network_widgets_page_get_state (_data13_->page);
	_tmp1_ = _tmp0_;
	network_widgets_device_item_switch_status (self, NETWORK_UTILS_CUSTOM_MODE_INVALID, &_tmp1_);
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda6_ (self);
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_construct_from_page (GType object_type,
                                                 NetworkWidgetsPage* page,
                                                 const gchar* icon_name)
{
	NetworkWidgetsDeviceItem * self = NULL;
	Block13Data* _data13_;
	NetworkWidgetsPage* _tmp0_;
	NMDevice* _tmp1_;
	NMDevice* _tmp2_;
	NetworkState _tmp3_;
	NetworkState _tmp4_;
	g_return_val_if_fail (page != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	_data13_ = g_slice_new0 (Block13Data);
	_data13_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (page);
	_g_object_unref0 (_data13_->page);
	_data13_->page = _tmp0_;
	_tmp1_ = network_widgets_page_get_device (_data13_->page);
	_tmp2_ = _tmp1_;
	self = (NetworkWidgetsDeviceItem*) g_object_new (object_type, "device", _tmp2_, "icon-name", icon_name, "item-type", NETWORK_UTILS_ITEM_TYPE_DEVICE, "page", _data13_->page, NULL);
	_data13_->self = g_object_ref (self);
	g_object_bind_property_with_closures ((GObject*) _data13_->page, "title", (GObject*) self, "title", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_object_bind_property_with_closures ((GObject*) _data13_->page, "icon-name", (GObject*) self, "icon-name", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp3_ = network_widgets_page_get_state (_data13_->page);
	_tmp4_ = _tmp3_;
	network_widgets_device_item_switch_status (self, NETWORK_UTILS_CUSTOM_MODE_INVALID, &_tmp4_);
	g_signal_connect_data ((GObject*) _data13_->page, "notify::state", (GCallback) ___lambda6__g_object_notify, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
	block13_data_unref (_data13_);
	_data13_ = NULL;
	return self;
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_new_from_page (NetworkWidgetsPage* page,
                                           const gchar* icon_name)
{
	return network_widgets_device_item_construct_from_page (NETWORK_WIDGETS_TYPE_DEVICE_ITEM, page, icon_name);
}

void
network_widgets_device_item_switch_status (NetworkWidgetsDeviceItem* self,
                                           NetworkUtilsCustomMode custom_mode,
                                           NetworkState* state)
{
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	g_return_if_fail (self != NULL);
	if (state != NULL) {
		gchar* _tmp4_;
		gchar* _tmp5_;
		switch (*state) {
			case NETWORK_STATE_CONNECTED_WIFI:
			case NETWORK_STATE_CONNECTED_WIFI_WEAK:
			case NETWORK_STATE_CONNECTED_WIFI_OK:
			case NETWORK_STATE_CONNECTED_WIFI_GOOD:
			case NETWORK_STATE_CONNECTED_WIFI_EXCELLENT:
			case NETWORK_STATE_CONNECTED_WIRED:
			case NETWORK_STATE_CONNECTED_VPN:
			case NETWORK_STATE_CONNECTED_MOBILE:
			{
				GtkImage* _tmp0_;
				_tmp0_ = self->priv->status_image;
				g_object_set (_tmp0_, "icon-name", "user-available", NULL);
				break;
			}
			case NETWORK_STATE_DISCONNECTED:
			{
				GtkImage* _tmp1_;
				_tmp1_ = self->priv->status_image;
				g_object_set (_tmp1_, "icon-name", "user-offline", NULL);
				break;
			}
			case NETWORK_STATE_FAILED_WIRED:
			case NETWORK_STATE_FAILED_WIFI:
			case NETWORK_STATE_FAILED_VPN:
			case NETWORK_STATE_FAILED_MOBILE:
			{
				GtkImage* _tmp2_;
				_tmp2_ = self->priv->status_image;
				g_object_set (_tmp2_, "icon-name", "user-busy", NULL);
				break;
			}
			default:
			{
				GtkImage* _tmp3_;
				_tmp3_ = self->priv->status_image;
				g_object_set (_tmp3_, "icon-name", "user-away", NULL);
				break;
			}
		}
		_tmp4_ = network_state_to_string (*state);
		_tmp5_ = _tmp4_;
		network_widgets_device_item_set_subtitle (self, _tmp5_);
		_g_free0 (_tmp5_);
	} else {
		if (custom_mode != NETWORK_UTILS_CUSTOM_MODE_INVALID) {
			switch (custom_mode) {
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_NONE:
				{
					GtkImage* _tmp6_;
					network_widgets_device_item_set_subtitle (self, _ ("Disabled"));
					_tmp6_ = self->priv->status_image;
					g_object_set (_tmp6_, "icon-name", "user-offline", NULL);
					break;
				}
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_MANUAL:
				{
					GtkImage* _tmp7_;
					network_widgets_device_item_set_subtitle (self, _ ("Enabled (manual mode)"));
					_tmp7_ = self->priv->status_image;
					g_object_set (_tmp7_, "icon-name", "user-available", NULL);
					break;
				}
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_AUTO:
				{
					GtkImage* _tmp8_;
					network_widgets_device_item_set_subtitle (self, _ ("Enabled (auto mode)"));
					_tmp8_ = self->priv->status_image;
					g_object_set (_tmp8_, "icon-name", "user-available", NULL);
					break;
				}
				default:
				break;
			}
		}
	}
	_tmp9_ = self->priv->_subtitle;
	_tmp10_ = g_strconcat ("<span font_size='small'>", _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "</span>", NULL);
	_tmp13_ = _tmp12_;
	network_widgets_device_item_set_subtitle (self, _tmp13_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
}

NMDevice*
network_widgets_device_item_get_device (NetworkWidgetsDeviceItem* self)
{
	NMDevice* result;
	NMDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static void
network_widgets_device_item_set_device (NetworkWidgetsDeviceItem* self,
                                        NMDevice* value)
{
	g_return_if_fail (self != NULL);
	if (network_widgets_device_item_get_device (self) != value) {
		NMDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY]);
	}
}

NetworkWidgetsPage*
network_widgets_device_item_get_page (NetworkWidgetsDeviceItem* self)
{
	NetworkWidgetsPage* result;
	NetworkWidgetsPage* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_page;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_page (NetworkWidgetsDeviceItem* self,
                                      NetworkWidgetsPage* value)
{
	g_return_if_fail (self != NULL);
	if (network_widgets_device_item_get_page (self) != value) {
		NetworkWidgetsPage* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_page);
		self->priv->_page = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY]);
	}
}

const gchar*
network_widgets_device_item_get_title (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_title (NetworkWidgetsDeviceItem* self,
                                       const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, network_widgets_device_item_get_title (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY]);
	}
}

const gchar*
network_widgets_device_item_get_subtitle (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_subtitle;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_subtitle (NetworkWidgetsDeviceItem* self,
                                          const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, network_widgets_device_item_get_subtitle (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_subtitle);
		self->priv->_subtitle = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY]);
	}
}

const gchar*
network_widgets_device_item_get_icon_name (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_icon_name (NetworkWidgetsDeviceItem* self,
                                           const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, network_widgets_device_item_get_icon_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY]);
	}
}

NetworkUtilsItemType
network_widgets_device_item_get_item_type (NetworkWidgetsDeviceItem* self)
{
	NetworkUtilsItemType result;
	NetworkUtilsItemType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_item_type;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_item_type (NetworkWidgetsDeviceItem* self,
                                           NetworkUtilsItemType value)
{
	g_return_if_fail (self != NULL);
	if (network_widgets_device_item_get_item_type (self) != value) {
		self->priv->_item_type = value;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY]);
	}
}

static GObject *
network_widgets_device_item_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsDeviceItem * self;
	GtkImage* row_image = NULL;
	const gchar* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkLabel* row_title = NULL;
	const gchar* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* row_description = NULL;
	const gchar* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkImage* _tmp17_;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp20_;
	GtkOverlay* _tmp21_;
	GtkOverlay* _tmp22_;
	GtkImage* _tmp23_;
	GtkOverlay* _tmp24_;
	GtkImage* _tmp25_;
	GtkGrid* row_grid = NULL;
	GtkGrid* _tmp26_;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	GtkGrid* _tmp29_;
	GtkGrid* _tmp30_;
	GtkOverlay* _tmp31_;
	GtkGrid* _tmp32_;
	GtkLabel* _tmp33_;
	GtkGrid* _tmp34_;
	GtkLabel* _tmp35_;
	GtkGrid* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GtkImage* _tmp39_;
	parent_class = G_OBJECT_CLASS (network_widgets_device_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	_tmp0_ = self->priv->_icon_name;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp1_);
	row_image = _tmp1_;
	_tmp2_ = row_image;
	gtk_image_set_pixel_size (_tmp2_, 32);
	_tmp3_ = self->priv->_title;
	_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
	g_object_ref_sink (_tmp4_);
	row_title = _tmp4_;
	_tmp5_ = row_title;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp7_ = row_title;
	gtk_label_set_ellipsize (_tmp7_, PANGO_ELLIPSIZE_END);
	_tmp8_ = row_title;
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
	_tmp9_ = row_title;
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_START);
	_tmp10_ = self->priv->_subtitle;
	_tmp11_ = (GtkLabel*) gtk_label_new (_tmp10_);
	g_object_ref_sink (_tmp11_);
	row_description = _tmp11_;
	_tmp12_ = row_description;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp12_, 2);
	_tmp13_ = row_description;
	gtk_label_set_use_markup (_tmp13_, TRUE);
	_tmp14_ = row_description;
	gtk_label_set_ellipsize (_tmp14_, PANGO_ELLIPSIZE_END);
	_tmp15_ = row_description;
	gtk_widget_set_halign ((GtkWidget*) _tmp15_, GTK_ALIGN_START);
	_tmp16_ = row_description;
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
	_tmp17_ = (GtkImage*) gtk_image_new_from_icon_name ("user-available", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->status_image);
	self->priv->status_image = _tmp17_;
	_tmp18_ = self->priv->status_image;
	_tmp19_ = self->priv->status_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp19_, GTK_ALIGN_END);
	gtk_widget_set_halign ((GtkWidget*) _tmp18_, GTK_ALIGN_END);
	_tmp20_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp20_);
	overlay = _tmp20_;
	_tmp21_ = overlay;
	g_object_set ((GtkWidget*) _tmp21_, "width-request", 38, NULL);
	_tmp22_ = overlay;
	_tmp23_ = row_image;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = overlay;
	_tmp25_ = self->priv->status_image;
	gtk_overlay_add_overlay (_tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp26_);
	row_grid = _tmp26_;
	_tmp27_ = row_grid;
	g_object_set ((GtkWidget*) _tmp27_, "margin", 6, NULL);
	_tmp28_ = row_grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp28_, 3);
	_tmp29_ = row_grid;
	gtk_grid_set_column_spacing (_tmp29_, 3);
	_tmp30_ = row_grid;
	_tmp31_ = overlay;
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 0, 0, 1, 2);
	_tmp32_ = row_grid;
	_tmp33_ = row_title;
	gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 1, 0, 1, 1);
	_tmp34_ = row_grid;
	_tmp35_ = row_description;
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 1, 1, 1, 1);
	_tmp36_ = row_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp36_);
	_tmp37_ = row_title;
	g_object_bind_property_with_closures ((GObject*) self, "title", (GObject*) _tmp37_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp38_ = row_description;
	g_object_bind_property_with_closures ((GObject*) self, "subtitle", (GObject*) _tmp38_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp39_ = row_image;
	g_object_bind_property_with_closures ((GObject*) self, "icon-name", (GObject*) _tmp39_, "icon-name", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (row_grid);
	_g_object_unref0 (overlay);
	_g_object_unref0 (row_description);
	_g_object_unref0 (row_title);
	_g_object_unref0 (row_image);
	return obj;
}

static void
network_widgets_device_item_class_init (NetworkWidgetsDeviceItemClass * klass,
                                        gpointer klass_data)
{
	network_widgets_device_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsDeviceItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_network_widgets_device_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_widgets_device_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_widgets_device_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_widgets_device_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", nm_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", NETWORK_WIDGETS_TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY] = g_param_spec_enum ("item-type", "item-type", "item-type", NETWORK_UTILS_TYPE_ITEM_TYPE, NETWORK_UTILS_ITEM_TYPE_INVALID, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
network_widgets_device_item_instance_init (NetworkWidgetsDeviceItem * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	self->priv = network_widgets_device_item_get_instance_private (self);
	self->priv->_device = NULL;
	self->priv->_page = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->_title = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->_subtitle = _tmp1_;
	_tmp2_ = g_strdup ("network-wired");
	self->priv->_icon_name = _tmp2_;
	self->priv->_item_type = NETWORK_UTILS_ITEM_TYPE_INVALID;
}

static void
network_widgets_device_item_finalize (GObject * obj)
{
	NetworkWidgetsDeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->_page);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_subtitle);
	_g_free0 (self->priv->_icon_name);
	_g_object_unref0 (self->priv->status_image);
	G_OBJECT_CLASS (network_widgets_device_item_parent_class)->finalize (obj);
}

GType
network_widgets_device_item_get_type (void)
{
	static volatile gsize network_widgets_device_item_type_id__volatile = 0;
	if (g_once_init_enter (&network_widgets_device_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsDeviceItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_device_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsDeviceItem), 0, (GInstanceInitFunc) network_widgets_device_item_instance_init, NULL };
		GType network_widgets_device_item_type_id;
		network_widgets_device_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWidgetsDeviceItem", &g_define_type_info, 0);
		NetworkWidgetsDeviceItem_private_offset = g_type_add_instance_private (network_widgets_device_item_type_id, sizeof (NetworkWidgetsDeviceItemPrivate));
		g_once_init_leave (&network_widgets_device_item_type_id__volatile, network_widgets_device_item_type_id);
	}
	return network_widgets_device_item_type_id__volatile;
}

static void
_vala_network_widgets_device_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NetworkWidgetsDeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	switch (property_id) {
		case NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY:
		g_value_set_object (value, network_widgets_device_item_get_device (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY:
		g_value_set_object (value, network_widgets_device_item_get_page (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY:
		g_value_set_string (value, network_widgets_device_item_get_title (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY:
		g_value_set_string (value, network_widgets_device_item_get_subtitle (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY:
		g_value_set_string (value, network_widgets_device_item_get_icon_name (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY:
		g_value_set_enum (value, network_widgets_device_item_get_item_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_widgets_device_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NetworkWidgetsDeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	switch (property_id) {
		case NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY:
		network_widgets_device_item_set_device (self, g_value_get_object (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY:
		network_widgets_device_item_set_page (self, g_value_get_object (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY:
		network_widgets_device_item_set_title (self, g_value_get_string (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY:
		network_widgets_device_item_set_subtitle (self, g_value_get_string (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY:
		network_widgets_device_item_set_icon_name (self, g_value_get_string (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY:
		network_widgets_device_item_set_item_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

