/* VPNMenuItem.c generated by valac 0.46.3, the Vala compiler
 * generated from VPNMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <NetworkManager.h>
#include <granite.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

#define NETWORK_TYPE_VPN_MENU_ITEM (network_vpn_menu_item_get_type ())
#define NETWORK_VPN_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem))
#define NETWORK_VPN_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItemClass))
#define NETWORK_IS_VPN_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_VPN_MENU_ITEM))
#define NETWORK_IS_VPN_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_VPN_MENU_ITEM))
#define NETWORK_VPN_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItemClass))

typedef struct _NetworkVPNMenuItem NetworkVPNMenuItem;
typedef struct _NetworkVPNMenuItemClass NetworkVPNMenuItemClass;
typedef struct _NetworkVPNMenuItemPrivate NetworkVPNMenuItemPrivate;
typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_MOBILE,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_MOBILE,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_MOBILE,
	NETWORK_STATE_FAILED_VPN
} NetworkState;

#define NETWORK_TYPE_STATE (network_state_get_type ())

#define NETWORK_WIDGETS_TYPE_VPN_INFO_DIALOG (network_widgets_vpn_info_dialog_get_type ())
#define NETWORK_WIDGETS_VPN_INFO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_WIDGETS_TYPE_VPN_INFO_DIALOG, NetworkWidgetsVPNInfoDialog))
#define NETWORK_WIDGETS_VPN_INFO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_WIDGETS_TYPE_VPN_INFO_DIALOG, NetworkWidgetsVPNInfoDialogClass))
#define NETWORK_WIDGETS_IS_VPN_INFO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_WIDGETS_TYPE_VPN_INFO_DIALOG))
#define NETWORK_WIDGETS_IS_VPN_INFO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_WIDGETS_TYPE_VPN_INFO_DIALOG))
#define NETWORK_WIDGETS_VPN_INFO_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_WIDGETS_TYPE_VPN_INFO_DIALOG, NetworkWidgetsVPNInfoDialogClass))

typedef struct _NetworkWidgetsVPNInfoDialog NetworkWidgetsVPNInfoDialog;
typedef struct _NetworkWidgetsVPNInfoDialogClass NetworkWidgetsVPNInfoDialogClass;
enum  {
	NETWORK_VPN_MENU_ITEM_0_PROPERTY,
	NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY,
	NETWORK_VPN_MENU_ITEM_STATE_PROPERTY,
	NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NetworkVPNMenuItem {
	GtkListBoxRow parent_instance;
	NetworkVPNMenuItemPrivate * priv;
};

struct _NetworkVPNMenuItemClass {
	GtkListBoxRowClass parent_class;
};

struct _NetworkVPNMenuItemPrivate {
	NMRemoteConnection* _connection;
	NetworkState _state;
	GtkButton* connect_button;
	GtkImage* vpn_state;
	GtkLabel* state_label;
	GtkLabel* vpn_label;
	NetworkWidgetsVPNInfoDialog* vpn_info_dialog;
};

static gint NetworkVPNMenuItem_private_offset;
static gpointer network_vpn_menu_item_parent_class = NULL;
static GtkSizeGroup* network_vpn_menu_item_size_group;
static GtkSizeGroup* network_vpn_menu_item_size_group = NULL;

GType network_vpn_menu_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NetworkVPNMenuItem, g_object_unref)
GType network_state_get_type (void) G_GNUC_CONST;
GType network_widgets_vpn_info_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NetworkWidgetsVPNInfoDialog, g_object_unref)
NetworkVPNMenuItem* network_vpn_menu_item_new (NMRemoteConnection* _connection);
NetworkVPNMenuItem* network_vpn_menu_item_construct (GType object_type,
                                                     NMRemoteConnection* _connection);
static void network_vpn_menu_item_update (NetworkVPNMenuItem* self);
NMRemoteConnection* network_vpn_menu_item_get_connection (NetworkVPNMenuItem* self);
NetworkState network_vpn_menu_item_get_state (NetworkVPNMenuItem* self);
gchar* network_state_to_string (NetworkState self);
static void network_vpn_menu_item_set_connection (NetworkVPNMenuItem* self,
                                           NMRemoteConnection* value);
void network_vpn_menu_item_set_state (NetworkVPNMenuItem* self,
                                      NetworkState value);
static GObject * network_vpn_menu_item_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
NetworkWidgetsVPNInfoDialog* network_widgets_vpn_info_dialog_new (NMRemoteConnection* connection);
NetworkWidgetsVPNInfoDialog* network_widgets_vpn_info_dialog_construct (GType object_type,
                                                                        NMRemoteConnection* connection);
static void _network_vpn_menu_item_update_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender,
                                                          gpointer self);
static void _network_vpn_menu_item___lambda24_ (NetworkVPNMenuItem* self);
static void __network_vpn_menu_item___lambda24__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _network_vpn_menu_item___lambda25_ (NetworkVPNMenuItem* self);
static void __network_vpn_menu_item___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void network_vpn_menu_item_finalize (GObject * obj);
static void _vala_network_vpn_menu_item_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_network_vpn_menu_item_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
network_vpn_menu_item_get_instance_private (NetworkVPNMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVPNMenuItem_private_offset);
}

NetworkVPNMenuItem*
network_vpn_menu_item_construct (GType object_type,
                                 NMRemoteConnection* _connection)
{
	NetworkVPNMenuItem * self = NULL;
	g_return_val_if_fail (_connection != NULL, NULL);
	self = (NetworkVPNMenuItem*) g_object_new (object_type, "connection", _connection, NULL);
	return self;
}

NetworkVPNMenuItem*
network_vpn_menu_item_new (NMRemoteConnection* _connection)
{
	return network_vpn_menu_item_construct (NETWORK_TYPE_VPN_MENU_ITEM, _connection);
}

static void
network_vpn_menu_item_update (NetworkVPNMenuItem* self)
{
	GtkLabel* _tmp0_;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
	NetworkState _tmp3_;
	GtkLabel* _tmp27_;
	NetworkState _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	NetworkWidgetsVPNInfoDialog* _tmp33_;
	NetworkState _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->vpn_label;
	_tmp1_ = self->priv->_connection;
	_tmp2_ = nm_connection_get_id ((NMConnection*) _tmp1_);
	gtk_label_set_label (_tmp0_, _tmp2_);
	_tmp3_ = self->priv->_state;
	switch (_tmp3_) {
		case NETWORK_STATE_FAILED_VPN:
		{
			GtkImage* _tmp4_;
			GtkButton* _tmp5_;
			GtkButton* _tmp6_;
			GtkButton* _tmp7_;
			GtkStyleContext* _tmp8_;
			_tmp4_ = self->priv->vpn_state;
			g_object_set (_tmp4_, "icon-name", "user-busy", NULL);
			_tmp5_ = self->priv->connect_button;
			gtk_button_set_label (_tmp5_, _ ("Connect"));
			_tmp6_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
			_tmp7_ = self->priv->connect_button;
			_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
			gtk_style_context_remove_class (_tmp8_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			break;
		}
		case NETWORK_STATE_CONNECTING_VPN:
		{
			GtkImage* _tmp9_;
			GtkButton* _tmp10_;
			GtkButton* _tmp11_;
			GtkStyleContext* _tmp12_;
			_tmp9_ = self->priv->vpn_state;
			g_object_set (_tmp9_, "icon-name", "user-away", NULL);
			_tmp10_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
			_tmp11_ = self->priv->connect_button;
			_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
			gtk_style_context_remove_class (_tmp12_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			break;
		}
		case NETWORK_STATE_CONNECTED_VPN:
		{
			GtkImage* _tmp13_;
			GtkButton* _tmp14_;
			GtkButton* _tmp15_;
			GtkButton* _tmp16_;
			GtkStyleContext* _tmp17_;
			_tmp13_ = self->priv->vpn_state;
			g_object_set (_tmp13_, "icon-name", "user-available", NULL);
			_tmp14_ = self->priv->connect_button;
			gtk_button_set_label (_tmp14_, _ ("Disconnect"));
			_tmp15_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, TRUE);
			_tmp16_ = self->priv->connect_button;
			_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
			gtk_style_context_add_class (_tmp17_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			break;
		}
		case NETWORK_STATE_DISCONNECTED:
		{
			GtkImage* _tmp18_;
			GtkButton* _tmp19_;
			GtkButton* _tmp20_;
			GtkButton* _tmp21_;
			GtkStyleContext* _tmp22_;
			_tmp18_ = self->priv->vpn_state;
			g_object_set (_tmp18_, "icon-name", "user-offline", NULL);
			_tmp19_ = self->priv->connect_button;
			gtk_button_set_label (_tmp19_, _ ("Connect"));
			_tmp20_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, TRUE);
			_tmp21_ = self->priv->connect_button;
			_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
			gtk_style_context_remove_class (_tmp22_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			break;
		}
		default:
		{
			GtkButton* _tmp23_;
			GtkButton* _tmp24_;
			GtkButton* _tmp25_;
			GtkStyleContext* _tmp26_;
			_tmp23_ = self->priv->connect_button;
			gtk_button_set_label (_tmp23_, _ ("Connect"));
			_tmp24_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, TRUE);
			_tmp25_ = self->priv->connect_button;
			_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
			gtk_style_context_remove_class (_tmp26_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			break;
		}
	}
	_tmp27_ = self->priv->state_label;
	_tmp28_ = self->priv->_state;
	_tmp29_ = network_state_to_string (_tmp28_);
	_tmp30_ = _tmp29_;
	_tmp31_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp30_);
	_tmp32_ = _tmp31_;
	gtk_label_set_label (_tmp27_, _tmp32_);
	_g_free0 (_tmp32_);
	_g_free0 (_tmp30_);
	_tmp33_ = self->priv->vpn_info_dialog;
	_tmp34_ = self->priv->_state;
	_tmp35_ = network_state_to_string (_tmp34_);
	_tmp36_ = _tmp35_;
	granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) _tmp33_, _tmp36_);
	_g_free0 (_tmp36_);
}

NMRemoteConnection*
network_vpn_menu_item_get_connection (NetworkVPNMenuItem* self)
{
	NMRemoteConnection* result;
	NMRemoteConnection* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_connection;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
network_vpn_menu_item_set_connection (NetworkVPNMenuItem* self,
                                      NMRemoteConnection* value)
{
	g_return_if_fail (self != NULL);
	if (network_vpn_menu_item_get_connection (self) != value) {
		NMRemoteConnection* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_connection);
		self->priv->_connection = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY]);
	}
}

NetworkState
network_vpn_menu_item_get_state (NetworkVPNMenuItem* self)
{
	NetworkState result;
	NetworkState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}

void
network_vpn_menu_item_set_state (NetworkVPNMenuItem* self,
                                 NetworkState value)
{
	g_return_if_fail (self != NULL);
	if (network_vpn_menu_item_get_state (self) != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_STATE_PROPERTY]);
	}
}

static void
_network_vpn_menu_item_update_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	network_vpn_menu_item_update ((NetworkVPNMenuItem*) self);
}

static void
_network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender,
                                                     gpointer self)
{
	network_vpn_menu_item_update ((NetworkVPNMenuItem*) self);
}

static void
_network_vpn_menu_item___lambda24_ (NetworkVPNMenuItem* self)
{
	g_signal_emit_by_name ((GtkListBoxRow*) self, "activate");
}

static void
__network_vpn_menu_item___lambda24__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
	_network_vpn_menu_item___lambda24_ ((NetworkVPNMenuItem*) self);
}

static void
_network_vpn_menu_item___lambda25_ (NetworkVPNMenuItem* self)
{
	NetworkWidgetsVPNInfoDialog* _tmp0_;
	GtkWidget* _tmp1_;
	NetworkWidgetsVPNInfoDialog* _tmp2_;
	NetworkWidgetsVPNInfoDialog* _tmp3_;
	_tmp0_ = self->priv->vpn_info_dialog;
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	gtk_window_set_transient_for ((GtkWindow*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
	_tmp2_ = self->priv->vpn_info_dialog;
	gtk_dialog_run ((GtkDialog*) _tmp2_);
	_tmp3_ = self->priv->vpn_info_dialog;
	gtk_widget_hide ((GtkWidget*) _tmp3_);
}

static void
__network_vpn_menu_item___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
	_network_vpn_menu_item___lambda25_ ((NetworkVPNMenuItem*) self);
}

static GObject *
network_vpn_menu_item_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkVPNMenuItem * self;
	GtkImage* image = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp7_;
	GtkOverlay* _tmp8_;
	GtkImage* _tmp9_;
	GtkOverlay* _tmp10_;
	GtkImage* _tmp11_;
	NMRemoteConnection* _tmp12_;
	const gchar* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	NMRemoteConnection* _tmp18_;
	NetworkWidgetsVPNInfoDialog* _tmp19_;
	GtkButton* vpn_info_button = NULL;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
	GtkImage* _tmp22_;
	GtkImage* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkButton* _tmp30_;
	GtkSizeGroup* _tmp31_;
	GtkButton* _tmp32_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkGrid* _tmp36_;
	GtkOverlay* _tmp37_;
	GtkGrid* _tmp38_;
	GtkLabel* _tmp39_;
	GtkGrid* _tmp40_;
	GtkLabel* _tmp41_;
	GtkGrid* _tmp42_;
	GtkButton* _tmp43_;
	GtkGrid* _tmp44_;
	GtkButton* _tmp45_;
	GtkGrid* _tmp46_;
	NMRemoteConnection* _tmp47_;
	GtkButton* _tmp48_;
	GtkButton* _tmp49_;
	parent_class = G_OBJECT_CLASS (network_vpn_menu_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("network-vpn", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp0_);
	image = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("user-offline", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->vpn_state);
	self->priv->vpn_state = _tmp1_;
	_tmp2_ = self->priv->vpn_state;
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
	_tmp3_ = self->priv->vpn_state;
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->state_label);
	self->priv->state_label = _tmp4_;
	_tmp5_ = self->priv->state_label;
	gtk_label_set_xalign (_tmp5_, (gfloat) 0);
	_tmp6_ = self->priv->state_label;
	gtk_label_set_use_markup (_tmp6_, TRUE);
	_tmp7_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp7_);
	overlay = _tmp7_;
	_tmp8_ = overlay;
	_tmp9_ = image;
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
	_tmp10_ = overlay;
	_tmp11_ = self->priv->vpn_state;
	gtk_overlay_add_overlay (_tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->_connection;
	_tmp13_ = nm_connection_get_id ((NMConnection*) _tmp12_);
	_tmp14_ = (GtkLabel*) gtk_label_new (_tmp13_);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->vpn_label);
	self->priv->vpn_label = _tmp14_;
	_tmp15_ = self->priv->vpn_label;
	gtk_label_set_ellipsize (_tmp15_, PANGO_ELLIPSIZE_END);
	_tmp16_ = self->priv->vpn_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
	_tmp17_ = self->priv->vpn_label;
	gtk_label_set_xalign (_tmp17_, (gfloat) 0);
	_tmp18_ = self->priv->_connection;
	_tmp19_ = network_widgets_vpn_info_dialog_new (_tmp18_);
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->vpn_info_dialog);
	self->priv->vpn_info_dialog = _tmp19_;
	_tmp20_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp20_);
	vpn_info_button = _tmp20_;
	_tmp21_ = vpn_info_button;
	_tmp22_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp22_);
	_tmp23_ = _tmp22_;
	gtk_button_set_image (_tmp21_, (GtkWidget*) _tmp23_);
	_g_object_unref0 (_tmp23_);
	_tmp24_ = vpn_info_button;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp24_, 3);
	_tmp25_ = vpn_info_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
	_tmp26_ = vpn_info_button;
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
	gtk_style_context_add_class (_tmp27_, GTK_STYLE_CLASS_FLAT);
	_tmp28_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->connect_button);
	self->priv->connect_button = _tmp28_;
	_tmp29_ = self->priv->connect_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
	_tmp30_ = self->priv->connect_button;
	gtk_button_set_label (_tmp30_, _ ("Connect"));
	_tmp31_ = network_vpn_menu_item_size_group;
	_tmp32_ = self->priv->connect_button;
	gtk_size_group_add_widget (_tmp31_, (GtkWidget*) _tmp32_);
	_tmp33_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp33_);
	grid = _tmp33_;
	_tmp34_ = grid;
	g_object_set ((GtkWidget*) _tmp34_, "margin", 6, NULL);
	_tmp35_ = grid;
	gtk_grid_set_column_spacing (_tmp35_, 6);
	_tmp36_ = grid;
	_tmp37_ = overlay;
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, 0, 0, 1, 2);
	_tmp38_ = grid;
	_tmp39_ = self->priv->vpn_label;
	gtk_grid_attach (_tmp38_, (GtkWidget*) _tmp39_, 1, 0, 1, 1);
	_tmp40_ = grid;
	_tmp41_ = self->priv->state_label;
	gtk_grid_attach (_tmp40_, (GtkWidget*) _tmp41_, 1, 1, 1, 1);
	_tmp42_ = grid;
	_tmp43_ = vpn_info_button;
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 2, 0, 1, 2);
	_tmp44_ = grid;
	_tmp45_ = self->priv->connect_button;
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 3, 0, 1, 2);
	_tmp46_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp46_);
	gtk_widget_show_all ((GtkWidget*) self);
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
	_tmp47_ = self->priv->_connection;
	g_signal_connect_object ((NMConnection*) _tmp47_, "changed", (GCallback) _network_vpn_menu_item_update_nm_connection_changed, self, 0);
	network_vpn_menu_item_update (self);
	_tmp48_ = self->priv->connect_button;
	g_signal_connect_object (_tmp48_, "clicked", (GCallback) __network_vpn_menu_item___lambda24__gtk_button_clicked, self, 0);
	_tmp49_ = vpn_info_button;
	g_signal_connect_object (_tmp49_, "clicked", (GCallback) __network_vpn_menu_item___lambda25__gtk_button_clicked, self, 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (vpn_info_button);
	_g_object_unref0 (overlay);
	_g_object_unref0 (image);
	return obj;
}

static void
network_vpn_menu_item_class_init (NetworkVPNMenuItemClass * klass,
                                  gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
	network_vpn_menu_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkVPNMenuItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_menu_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_menu_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_vpn_menu_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_vpn_menu_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", nm_remote_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_STATE_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	_g_object_unref0 (network_vpn_menu_item_size_group);
	network_vpn_menu_item_size_group = _tmp0_;
}

static void
network_vpn_menu_item_instance_init (NetworkVPNMenuItem * self,
                                     gpointer klass)
{
	self->priv = network_vpn_menu_item_get_instance_private (self);
	self->priv->_state = NETWORK_STATE_DISCONNECTED;
}

static void
network_vpn_menu_item_finalize (GObject * obj)
{
	NetworkVPNMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
	_g_object_unref0 (self->priv->_connection);
	_g_object_unref0 (self->priv->connect_button);
	_g_object_unref0 (self->priv->vpn_state);
	_g_object_unref0 (self->priv->state_label);
	_g_object_unref0 (self->priv->vpn_label);
	_g_object_unref0 (self->priv->vpn_info_dialog);
	G_OBJECT_CLASS (network_vpn_menu_item_parent_class)->finalize (obj);
}

GType
network_vpn_menu_item_get_type (void)
{
	static volatile gsize network_vpn_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&network_vpn_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkVPNMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVPNMenuItem), 0, (GInstanceInitFunc) network_vpn_menu_item_instance_init, NULL };
		GType network_vpn_menu_item_type_id;
		network_vpn_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkVPNMenuItem", &g_define_type_info, 0);
		NetworkVPNMenuItem_private_offset = g_type_add_instance_private (network_vpn_menu_item_type_id, sizeof (NetworkVPNMenuItemPrivate));
		g_once_init_leave (&network_vpn_menu_item_type_id__volatile, network_vpn_menu_item_type_id);
	}
	return network_vpn_menu_item_type_id__volatile;
}

static void
_vala_network_vpn_menu_item_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVPNMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
	switch (property_id) {
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
		g_value_set_object (value, network_vpn_menu_item_get_connection (self));
		break;
		case NETWORK_VPN_MENU_ITEM_STATE_PROPERTY:
		g_value_set_enum (value, network_vpn_menu_item_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_vpn_menu_item_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVPNMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
	switch (property_id) {
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
		network_vpn_menu_item_set_connection (self, g_value_get_object (value));
		break;
		case NETWORK_VPN_MENU_ITEM_STATE_PROPERTY:
		network_vpn_menu_item_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

